local Hermes = LibStub("AceAddon-3.0"):GetAddon("Hermes")
local LegacyUI = Hermes:GetModule("LegacyUI")

LegacyUI.THEMEABLE = {
	["padding"] = 1,
	["style"] = 1,
	["cellHideNoSender"] = 1,
	["cellHideNoAvailSender"] = 1,
	["cellAnchor"] = 1,
	["cellMax"] = 1,
	["cellDir"] = 1,
	["cellSide"] = 1,
	["cellBGColor"] = 1,
	["barFontSize"] = 1,
	["barW"] = 1,
	["barH"] = 1,
	["barGap"] = 1,
	["barPadding"] = 1,
	["barTexture"] = 1,
	["barFont"] = 1,
	["barCCA"] = 1,
	["barCCC"] = 1,
	["barCCU"] = 1,
	["barColorA"] = 1,
	["barColorC"] = 1,
	["barColorU"] = 1,
	["barBGCCC"] = 1,
	["barBGColorC"] = 1,
	["barCCAFont"] = 1,
	["barCCCFont"] = 1,
	["barCCUFont"] = 1,
	["barColorAFont"] = 1,
	["barColorCFont"] = 1,
	["barColorUFont"] = 1,
	["barTextRatio"] = 1,
	["barOutlineFont"] = 1,
	["btnColor"] = 1,
	["npH"] = 1,
	["npW"] = 1,
	["npFontSize"] = 1,
	["npTexColor"] = 1,
	["npCCBar"] = 1,
	["npCCFont"] = 1,
	["npFontColor"] = 1,
	["npBarColor"] = 1,
	["npTexture"] = 1,
	["npFont"] = 1,
	["npOutlineFont"] = 1,
	["npUseIcon"] = 1,
	["npUseNameplate"] = 1,
	["enableTooltip"] = 1,
}

LegacyUI.THEME_NAMES = {
	"Buttons: Simple",
	"Bar Style 1 (Vertical)",
	"Bar Style 1 (Horizontal)",
	"Bar Style 2 (Vertical)",
	"Bar Style 2 (Horizontal)",
	"Super Simple Bars (Vertical)",
	"Super Simple Bars (Horizontal)",
}

LegacyUI.THEMES = {

	["Buttons: Simple"] = {
		["btnColor"] = true,
		["style"] = "Buttons",
		["padding"] = 2,
		["enableTooltip"] = true,
	},
	["Bar Style 1 (Vertical)"] = {
		["npCCFont"] = true,
		["btnColor"] = true,
		["barBGCCC"] = false,
		["barBGColorC"] = {
			["r"] = 0,
			["g"] = 0,
			["b"] = 0,
			["a"] = 0.3,
		},
		["barColorC"] = {
			["a"] = 0.5200000107288361,
			["b"] = 0.5294117647058824,
			["g"] = 0.5294117647058824,
			["r"] = 0.5294117647058824,
		},
		["barCCCFont"] = false,
		["npW"] = 100,
		["barTexture"] = "Blizzard",
		["barColorU"] = {
			["a"] = 0.4900000095367432,
			["b"] = 0.06666666666666667,
			["g"] = 0.06666666666666667,
			["r"] = 0.06666666666666667,
		},
		["npBarColor"] = {
			["a"] = 1,
			["b"] = 0,
			["g"] = 1,
			["r"] = 0,
		},
		["barOutlineFont"] = false,
		["style"] = "Bars",
		["barPadding"] = 2,
		["npTexColor"] = {
			["a"] = 1,
			["b"] = 0.1686274509803922,
			["g"] = 0.1686274509803922,
			["r"] = 0.1686274509803922,
		},
		["npUseNameplate"] = true,
		["npFontColor"] = {
			["a"] = 1,
			["b"] = 1,
			["g"] = 1,
			["r"] = 1,
		},
		["barCCU"] = false,
		["barColorAFont"] = {
			["a"] = 1,
			["b"] = 0.9411764705882353,
			["g"] = 0.9411764705882353,
			["r"] = 0.9411764705882353,
		},
		["barColorA"] = {
			["a"] = 1,
			["b"] = 0.94,
			["g"] = 0.94,
			["r"] = 0.94,
		},
		["npFontSize"] = 0.6,
		["npFont"] = "Friz Quadrata TT",
		["barFont"] = "Friz Quadrata TT",
		["barCCUFont"] = false,
		["barColorUFont"] = {
			["a"] = 0.5200000107288361,
			["b"] = 1,
			["g"] = 1,
			["r"] = 1,
		},
		["barW"] = 174,
		["npTexture"] = "Blizzard",
		["npUseIcon"] = true,
		["barCCC"] = true,
		["barH"] = 20,
		["npOutlineFont"] = true,
		["barGap"] = 2,
		["npCCBar"] = false,
		["npH"] = 20,
		["cellDir"] = false,
		["barColorCFont"] = {
			["a"] = 0.550000011920929,
			["b"] = 1,
			["g"] = 1,
			["r"] = 1,
		},
		["barCCA"] = true,
		["barFontSize"] = 0.59,
		["barCCAFont"] = false,
		["cellSide"] = false,
		["barTextRatio"] = 50,
		["cellBGColor"] = {
			["a"] = 0.1299999952316284,
			["b"] = 0,
			["g"] = 0,
			["r"] = 0,
		},
		["padding"] = 2,
		["enableTooltip"] = true,
	},
	["Bar Style 1 (Horizontal)"] = {
		["npCCFont"] = true,
		["btnColor"] = true,
		["barBGCCC"] = false,
		["barBGColorC"] = {
			["r"] = 0,
			["g"] = 0,
			["b"] = 0,
			["a"] = 0.3,
		},
		["barColorC"] = {
			["a"] = 0.5200000107288361,
			["b"] = 0.5294117647058824,
			["g"] = 0.5294117647058824,
			["r"] = 0.5294117647058824,
		},
		["barCCCFont"] = false,
		["npW"] = 120,
		["barTexture"] = "Blizzard",
		["barColorU"] = {
			["a"] = 0.4900000095367432,
			["b"] = 0.06666666666666667,
			["g"] = 0.06666666666666667,
			["r"] = 0.06666666666666667,
		},
		["padding"] = 2,
		["barPadding"] = 2,
		["npBarColor"] = {
			["a"] = 1,
			["b"] = 0,
			["g"] = 1,
			["r"] = 0,
		},
		["npUseNameplate"] = true,
		["npFontColor"] = {
			["a"] = 1,
			["b"] = 1,
			["g"] = 1,
			["r"] = 1,
		},
		["barCCU"] = false,
		["cellBGColor"] = {
			["a"] = 0.1299999952316284,
			["b"] = 0,
			["g"] = 0,
			["r"] = 0,
		},
		["barColorA"] = {
			["a"] = 1,
			["b"] = 0.94,
			["g"] = 0.94,
			["r"] = 0.94,
		},
		["cellSide"] = false,
		["npFont"] = "Friz Quadrata TT",
		["npFontSize"] = 0.6,
		["barFont"] = "Friz Quadrata TT",
		["barCCUFont"] = false,
		["barFontSize"] = 0.59,
		["barColorCFont"] = {
			["a"] = 0.550000011920929,
			["b"] = 1,
			["g"] = 1,
			["r"] = 1,
		},
		["npTexture"] = "Blizzard",
		["barCCC"] = true,
		["barCCA"] = true,
		["barH"] = 20,
		["npOutlineFont"] = false,
		["barGap"] = 2,
		["npCCBar"] = false,
		["npH"] = 20,
		["cellDir"] = true,
		["npUseIcon"] = true,
		["barW"] = 120,
		["barColorUFont"] = {
			["a"] = 0.5200000107288361,
			["b"] = 1,
			["g"] = 1,
			["r"] = 1,
		},
		["barCCAFont"] = false,
		["barTextRatio"] = 50,
		["barColorAFont"] = {
			["a"] = 1,
			["b"] = 0.9411764705882353,
			["g"] = 0.9411764705882353,
			["r"] = 0.9411764705882353,
		},
		["npTexColor"] = {
			["a"] = 1,
			["b"] = 0.1686274509803922,
			["g"] = 0.1686274509803922,
			["r"] = 0.1686274509803922,
		},
		["style"] = "Bars",
		["barOutlineFont"] = false,
		["enableTooltip"] = true,
	},
	["Bar Style 2 (Vertical)"] = {
		["npCCFont"] = false,
		["btnColor"] = true,
		["barBGCCC"] = false,
		["barBGColorC"] = {
			["r"] = 0,
			["g"] = 0,
			["b"] = 0,
			["a"] = 0.3,
		},
		["barColorC"] = {
			["a"] = 0.5600000023841858,
			["b"] = 0.1411764705882353,
			["g"] = 0.5294117647058824,
			["r"] = 0.1529411764705883,
		},
		["barCCCFont"] = false,
		["npW"] = 100,
		["barTexture"] = "Blizzard",
		["barColorU"] = {
			["a"] = 0.1299999952316284,
			["b"] = 1,
			["g"] = 1,
			["r"] = 1,
		},
		["npBarColor"] = {
			["a"] = 1,
			["b"] = 0,
			["g"] = 1,
			["r"] = 0,
		},
		["barPadding"] = 2,
		["cellSide"] = false,
		["npUseNameplate"] = true,
		["npFontColor"] = {
			["a"] = 1,
			["b"] = 1,
			["g"] = 1,
			["r"] = 1,
		},
		["barCCU"] = false,
		["padding"] = 2,
		["cellBGColor"] = {
			["a"] = 0.6100000143051148,
			["b"] = 0,
			["g"] = 0,
			["r"] = 0,
		},
		["barColorA"] = {
			["a"] = 1,
			["b"] = 0.09411764705882353,
			["g"] = 0.9411764705882353,
			["r"] = 0,
		},
		["npFont"] = "Friz Quadrata TT",
		["npFontSize"] = 0.6,
		["barFont"] = "Friz Quadrata TT",
		["barCCUFont"] = false,
		["barFontSize"] = 0.6,
		["barCCA"] = false,
		["npTexture"] = "Blizzard",
		["barCCC"] = false,
		["barColorCFont"] = {
			["a"] = 0.7300000190734863,
			["b"] = 1,
			["g"] = 1,
			["r"] = 1,
		},
		["barH"] = 18,
		["npOutlineFont"] = false,
		["barGap"] = 0,
		["npCCBar"] = true,
		["npH"] = 20,
		["cellDir"] = false,
		["npUseIcon"] = true,
		["barW"] = 174,
		["barColorUFont"] = {
			["a"] = 0.8500000089406967,
			["b"] = 1,
			["g"] = 1,
			["r"] = 1,
		},
		["barCCAFont"] = false,
		["barTextRatio"] = 50,
		["barColorAFont"] = {
			["a"] = 1,
			["b"] = 0.9411764705882353,
			["g"] = 0.9411764705882353,
			["r"] = 0.9411764705882353,
		},
		["npTexColor"] = {
			["a"] = 1,
			["b"] = 0.08627450980392157,
			["g"] = 0.08627450980392157,
			["r"] = 0.08627450980392157,
		},
		["style"] = "Bars",
		["barOutlineFont"] = false,
		["enableTooltip"] = true,
	},
	["Bar Style 2 (Horizontal)"] = {
		["npCCFont"] = false,
		["btnColor"] = true,
		["barBGCCC"] = false,
		["barBGColorC"] = {
			["r"] = 0,
			["g"] = 0,
			["b"] = 0,
			["a"] = 0.3,
		},
		["barColorC"] = {
			["a"] = 0.5600000023841858,
			["b"] = 0.1411764705882353,
			["g"] = 0.5294117647058824,
			["r"] = 0.1529411764705883,
		},
		["barCCCFont"] = false,
		["npW"] = 120,
		["barOutlineFont"] = false,
		["barTexture"] = "Blizzard",
		["barColorU"] = {
			["a"] = 0.1299999952316284,
			["b"] = 1,
			["g"] = 1,
			["r"] = 1,
		},
		["style"] = "Bars",
		["npTexColor"] = {
			["a"] = 1,
			["b"] = 0.08627450980392157,
			["g"] = 0.08627450980392157,
			["r"] = 0.08627450980392157,
		},
		["barPadding"] = 2,
		["barColorAFont"] = {
			["a"] = 1,
			["b"] = 0.9411764705882353,
			["g"] = 0.9411764705882353,
			["r"] = 0.9411764705882353,
		},
		["npUseNameplate"] = true,
		["npFontColor"] = {
			["a"] = 1,
			["b"] = 1,
			["g"] = 1,
			["r"] = 1,
		},
		["barCCU"] = false,
		["cellBGColor"] = {
			["a"] = 0.6100000143051148,
			["b"] = 0,
			["g"] = 0,
			["r"] = 0,
		},
		["barColorA"] = {
			["a"] = 1,
			["b"] = 0.09411764705882353,
			["g"] = 0.9411764705882353,
			["r"] = 0,
		},
		["npFont"] = "Friz Quadrata TT",
		["npFontSize"] = 0.6,
		["barColorUFont"] = {
			["a"] = 0.8500000089406967,
			["b"] = 1,
			["g"] = 1,
			["r"] = 1,
		},
		["barCCUFont"] = false,
		["barW"] = 120,
		["npUseIcon"] = true,
		["npTexture"] = "Blizzard",
		["barCCC"] = false,
		["barCCA"] = false,
		["barH"] = 18,
		["npOutlineFont"] = false,
		["barGap"] = 0,
		["npCCBar"] = true,
		["npH"] = 20,
		["cellDir"] = true,
		["barColorCFont"] = {
			["a"] = 0.7300000190734863,
			["b"] = 1,
			["g"] = 1,
			["r"] = 1,
		},
		["barFontSize"] = 0.6,
		["barFont"] = "Friz Quadrata TT",
		["barCCAFont"] = false,
		["cellSide"] = false,
		["barTextRatio"] = 50,
		["npBarColor"] = {
			["a"] = 1,
			["b"] = 0,
			["g"] = 1,
			["r"] = 0,
		},
		["padding"] = 2,
		["enableTooltip"] = true,
	},
	["Super Simple Bars (Vertical)"] = {
		["npCCFont"] = false,
		["btnColor"] = true,
		["barBGCCC"] = false,
		["barBGColorC"] = {
			["r"] = 0,
			["g"] = 0,
			["b"] = 0,
			["a"] = 0.3,
		},
		["barColorC"] = {
			["a"] = 0.5600000023841858,
			["b"] = 0.1411764705882353,
			["g"] = 0.5294117647058824,
			["r"] = 0.1529411764705883,
		},
		["barCCCFont"] = false,
		["npW"] = 20,
		["barTexture"] = "Blizzard",
		["barColorU"] = {
			["a"] = 0.1299999952316284,
			["b"] = 1,
			["g"] = 1,
			["r"] = 1,
		},
		["padding"] = 4,
		["barPadding"] = 0,
		["npBarColor"] = {
			["a"] = 1,
			["b"] = 0,
			["g"] = 1,
			["r"] = 0,
		},
		["npUseNameplate"] = true,
		["npFontColor"] = {
			["a"] = 1,
			["b"] = 1,
			["g"] = 1,
			["r"] = 1,
		},
		["barCCU"] = false,
		["cellBGColor"] = {
			["a"] = 0,
			["b"] = 0,
			["g"] = 0,
			["r"] = 0,
		},
		["barColorA"] = {
			["a"] = 1,
			["b"] = 0.09411764705882353,
			["g"] = 0.9411764705882353,
			["r"] = 0,
		},
		["cellSide"] = false,
		["npFont"] = "Friz Quadrata TT",
		["npFontSize"] = 0.6,
		["barFont"] = "Friz Quadrata TT",
		["barCCUFont"] = false,
		["barFontSize"] = 0.6,
		["barColorCFont"] = {
			["a"] = 0.7300000190734863,
			["b"] = 1,
			["g"] = 1,
			["r"] = 1,
		},
		["npTexture"] = "Blizzard",
		["barCCC"] = true,
		["barCCA"] = true,
		["barH"] = 18,
		["npOutlineFont"] = false,
		["barGap"] = 1,
		["npCCBar"] = false,
		["npH"] = 20,
		["cellDir"] = false,
		["npUseIcon"] = false,
		["barW"] = 200,
		["barColorUFont"] = {
			["a"] = 0.8500000089406967,
			["b"] = 1,
			["g"] = 1,
			["r"] = 1,
		},
		["barCCAFont"] = false,
		["barTextRatio"] = 50,
		["barColorAFont"] = {
			["a"] = 1,
			["b"] = 0.9411764705882353,
			["g"] = 0.9411764705882353,
			["r"] = 0.9411764705882353,
		},
		["npTexColor"] = {
			["a"] = 0,
			["b"] = 0.08627450980392157,
			["g"] = 0.08627450980392157,
			["r"] = 0.08627450980392157,
		},
		["style"] = "Bars",
		["barOutlineFont"] = false,
		["enableTooltip"] = true,
	},
	["Super Simple Bars (Horizontal)"] = {
		["npCCFont"] = false,
		["btnColor"] = true,
		["barBGCCC"] = false,
		["barBGColorC"] = {
			["r"] = 0,
			["g"] = 0,
			["b"] = 0,
			["a"] = 0.3,
		},
		["barColorC"] = {
			["a"] = 0.5600000023841858,
			["b"] = 0.1411764705882353,
			["g"] = 0.5294117647058824,
			["r"] = 0.1529411764705883,
		},
		["barCCCFont"] = false,
		["npW"] = 20,
		["barTexture"] = "Blizzard",
		["barColorU"] = {
			["a"] = 0.1299999952316284,
			["b"] = 1,
			["g"] = 1,
			["r"] = 1,
		},
		["padding"] = 0,
		["barPadding"] = 0,
		["npBarColor"] = {
			["a"] = 1,
			["b"] = 0,
			["g"] = 1,
			["r"] = 0,
		},
		["npUseNameplate"] = true,
		["npFontColor"] = {
			["a"] = 1,
			["b"] = 1,
			["g"] = 1,
			["r"] = 1,
		},
		["barCCU"] = true,
		["cellBGColor"] = {
			["a"] = 0,
			["b"] = 0,
			["g"] = 0,
			["r"] = 0,
		},
		["barColorA"] = {
			["a"] = 1,
			["b"] = 0.09411764705882353,
			["g"] = 0.9411764705882353,
			["r"] = 0,
		},
		["cellSide"] = false,
		["npFont"] = "Friz Quadrata TT",
		["npFontSize"] = 0.6,
		["barFont"] = "Friz Quadrata TT",
		["barCCUFont"] = false,
		["barFontSize"] = 0.6,
		["barColorCFont"] = {
			["a"] = 0.7300000190734863,
			["b"] = 1,
			["g"] = 1,
			["r"] = 1,
		},
		["npTexture"] = "Blizzard",
		["barCCC"] = true,
		["barCCA"] = true,
		["barH"] = 20,
		["npOutlineFont"] = false,
		["barGap"] = 3,
		["npCCBar"] = false,
		["npH"] = 20,
		["cellDir"] = true,
		["npUseIcon"] = true,
		["barW"] = 100,
		["barColorUFont"] = {
			["a"] = 0.8500000089406967,
			["b"] = 1,
			["g"] = 1,
			["r"] = 1,
		},
		["barCCAFont"] = false,
		["barTextRatio"] = 50,
		["barColorAFont"] = {
			["a"] = 1,
			["b"] = 0.9411764705882353,
			["g"] = 0.9411764705882353,
			["r"] = 0.9411764705882353,
		},
		["npTexColor"] = {
			["a"] = 0,
			["b"] = 0.08627450980392157,
			["g"] = 0.08627450980392157,
			["r"] = 0.08627450980392157,
		},
		["style"] = "Bars",
		["barOutlineFont"] = false,
		["enableTooltip"] = true,
	},
}