
  -- // rBuffFrameStyler
  -- // zork - 2012

  -----------------------------
  -- INIT
  -----------------------------

  --get the addon namespace
  local addon, ns = ...
  local cfg = CreateFrame("Frame")
  ns.cfg = cfg

  -----------------------------
  -- CONFIG
  -----------------------------

  --adjust the oneletter abbrev?
  cfg.adjustOneletterAbbrev = true
  
  --scale of the consolidated tooltip
  cfg.consolidatedTooltipScale = 1
  
  --combine buff and debuff frame - should buffs and debuffs be displayed in one single frame?
  --if you disable this it is intended that you unlock the buff and debuffs and move them apart!
  cfg.combineBuffsAndDebuffs = true

  --buff frame settings
  cfg.buffFrame = {
    pos             = { a1 = "TOPRIGHT", af = "UIParent", a2 = "TOPRIGHT", x = -20, y = -21 },
    gap             = 40, --gap between buff and debuff rows
    userplaced      = false, --want to place the bar somewhere else?
    rowSpacing      = 1,
    colSpacing      = 1,
    buttonsPerRow   = 10,
    button = {
      size              = 30,
    },
    icon = {
      padding           = 0,
    },
    border = {
      texture           = "Interface\\AddOns\\rBuffFrameStyler\\media\\debuff",
      color             = { r = 0, g = 0, b = 0, },
      classcolored      = false,
    },
    background = {
      show              = true,   --show backdrop
      edgeFile          = "Interface\ChatFrame\ChatFrameBackground",
      color             = { r = 0, g = 0, b = 0, a = 1},
      classcolored      = false,
      inset             = 1,
      padding           = 0,
    },
    duration = {
      font              = "Interface\\Addons\\SharedMedia\\fonts\\font.ttf",
      size              = 8,
      pos               = { a1 = "CENTER", x = 2, y = -1 },
    },
    count = {
      font              = "Interface\\Addons\\SharedMedia\\fonts\\font.ttf",
      size              = 8,
      pos               = { a1 = "BOTTOMRIGHT", x =0, y = 2 },
    },
  }

  --debuff frame settings
  cfg.debuffFrame = {
    pos             = { a1 = "TOPRIGHT", af = "rBFS_BuffDragFrame", a2 = "BOTTOMRIGHT", x = 0, y = -10 },
    userplaced      = false, --want to place the bar somewhere else?
    rowSpacing      = 1,
    colSpacing      = 1,
    buttonsPerRow   = 10,
    button = {
      size              = 30,
    },
    icon = {
      padding           = 0,
    },
    border = {
      texture           = "Interface\\AddOns\\rBuffFrameStyler\\media\\debuff",
    },
    background = {
      show              = true,   --show backdrop
      edgeFile          = "Interface\ChatFrame\ChatFrameBackground",
      color             = { r = 0, g = 0, b = 0, a = 1},
      classcolored      = false,
      inset             = 1,
      padding           = 0,
    },
    duration = {
      font              = "Interface\\Addons\\SharedMedia\\fonts\\font.ttf",
      size              = 8,
      pos               = { a1 = "CENTER", x = 2, y = -1 },
    },
    count = {
      font              = "Interface\\Addons\\SharedMedia\\fonts\\font.ttf",
      size              = 8,
      pos               = { a1 = "BOTTOMRIGHT", x =0, y = 2 },
    },
  }

