-- Tables ----------------
--------------------------
stExp.FactionInfo = {
	[1] = {{ 204/255, 77/255,  56/255 }, "Hated", "FFaa4646"},
	[2] = {{ 204/255, 77/255,  56/255 }, "Hostile", "FFaa4646"},
	[3] = {{ 191/255, 69/255,  0/255 }, "Unfriendly", "FFaa4646"},
	[4] = {{ 172/255, 134/255, 0/255 }, "Neutral", "FFc8b464"},
	[5] = {{ 0/255,  115/255, 19/255 }, "Friendly", "FF4baf4b"},
	[6] = {{ 0/255,  115/255, 19/255 }, "Honored", "FF4baf4b"},
	[7] = {{ 0/255,  115/255, 19/255 }, "Revered", "FF4baf4b"},
	[8] = {{ 0/255,  115/255, 19/255 }, "Exalted","FF9bff9b"},

-- stExp.FactionInfo = {
	-- [1] = {{ 170/255, 70/255,  70/255 }, "Hated", "FFaa4646"},
	-- [2] = {{ 170/255, 70/255,  70/255 }, "Hostile", "FFaa4646"},
	-- [3] = {{ 170/255, 70/255,  70/255 }, "Unfriendly", "FFaa4646"},
	-- [4] = {{ 200/255, 180/255, 100/255 }, "Neutral", "FFc8b464"},
	-- [5] = {{ 75/255,  175/255, 75/255 }, "Friendly", "FF4baf4b"},
	-- [6] = {{ 75/255,  175/255, 75/255 }, "Honored", "FF4baf4b"},
	-- [7] = {{ 75/255,  175/255, 75/255 }, "Revered", "FF4baf4b"},
	-- [8] = {{ 155/255,  255/255, 155/255 }, "Exalted","FF9bff9b"},
}

-- Functions -------------
--------------------------
function stExp.ShortValue(value)
	if value >= 1e6 then
		return ("%.2fm"):format(value / 1e6):gsub("%.?0+([km])$", "%1")
	elseif value >= 1e3 or value <= -1e3 then
		return ("%.1fk"):format(value / 1e3):gsub("%.?+([km])$", "%1")
	else
		return value
	end
end

function stExp.CommaValue(amount)
	local formatted = amount
	while true do  
		formatted, k = string.gsub(formatted, "^(-?%d+)(%d%d%d)", '%1,%2')
		if (k==0) then
			break
		end
	end
	return formatted
end

function stExp.Colorize(r)
	return stExp.FactionInfo[r][3]
end

function stExp.IsMaxLevel()
	if UnitLevel("player") == MAX_PLAYER_LEVEL then
		return true
	end
end

function stExp.GuildIsMaxLevel()
	if GetGuildLevel() == MAX_GUILD_LEVEL then
		return true
	end
end